;BlackJack - Copyright2003 Reel Media Productions
;written by Paul Leischow, July 21, 2003
;
;A good example of how to make use of the
;Microsoft Cards.DLL (included in zip)
;
;Also includes PureVision Project file (.gui)
;http://www.reelmediaproductions.com/purevision
;


;-Init Includes
XIncludeFile "Cards_Constants.pb"
XIncludeFile "Cards_Windows.pb"



tempdir.s=Space(512)
GetTempPath_(Len(tempdir),@tempdir)
If Right(tempdir,1)<>"\":tempdir+"\":EndIf
If CreateFile(0,tempdir+"Cards32.dll")
  WriteData(?carddll,?carddllend-?carddll)
  CloseFile(0)
EndIf




#DLL=0
If OpenLibrary(#DLL,tempdir+"Cards32.dll")=0
  MessageRequester("Error","Could not Initialize DLL",#MB_ICONERROR)  
  End
EndIf
cdtInit   =IsFunction(#DLL,"cdtInit")
cdtDrawExt=IsFunction(#DLL,"cdtDrawExt")
cdtTerm   =IsFunction(#DLL,"cdtTerm")



Structure Deck
  card.l
  value.l
EndStructure
Dim card.Deck(6)
Dim used.l(51)



Procedure Deal_Card(flag.l)
  Shared reshuffle.l
  quit=0
  Repeat
    face=Random(12)
    suit=Random(3)
    card=(face*4)+suit
    If used(card)=0
      used(card)=1
      card(flag)\card=card

      If face>0 And face<10
        card(flag)\value=face+1
        Else
        If face=0
          card(flag)\value=11
          Else
          card(flag)\value=10
        EndIf        
      EndIf 
           
      reshuffle+1
      If reshuffle=52
        Dim used(51)
        reshuffle=0
      EndIf
      quit=1
    EndIf    
  Until quit
EndProcedure 


Procedure Draw_Cards(DrawDLL.l,Cash.l)
  hDC=StartDrawing(WindowOutput())
    x=15
    For tmp=0 To 1
      If card(tmp)\value=0
        CallFunctionFast(DrawDLL,hDC,x,30,75,100,54,1,0)
        Else        
        CallFunctionFast(DrawDLL,hDC,x,30,75,100,card(tmp)\card,0,0)
      EndIf
      x+80
    Next
    x=15
    For tmp=2 To 6
      If card(tmp)\value=0
        CallFunctionFast(DrawDLL,hDC,x,175,75,100,54,1,0)
        Else        
        CallFunctionFast(DrawDLL,hDC,x,175,75,100,card(tmp)\card,0,0)
      EndIf
      x+80
    Next
  StopDrawing()
  SetGadgetText(#Gadget_Main_Cash,"Cash: $"+Str(Cash))
EndProcedure


Procedure.l Player_Score()
  score=0
  For tmp=2 To 6
    score+card(tmp)\value
  Next
  If score>21
    For tmp=2 To 6
      If card(tmp)\value=11
        card(tmp)\value=1
        score-10
        tmp=6
      EndIf
    Next
  EndIf  
  ProcedureReturn score
EndProcedure 


Procedure.l Dealer_Score()
  score=0
  For tmp=0 To 1
    score+card(tmp)\value
  Next
  ProcedureReturn score
EndProcedure 


Procedure Game_Over(Msg.s)
  HideGadget(#Gadget_Main_Hit,1)
  HideGadget(#Gadget_Main_Stand,1)
  HideGadget(#Gadget_Main_Info,0)
  SetGadgetText(#Gadget_Main_Info,Msg)  
EndProcedure





;--------------------
;-Main Loop
If Window_About()
  SetWindowPos_(WindowID(#Window_About),#HWND_TOPMOST,0,0,0,0,16|2|1)
  txt.s=Chr(10)+"BlackJack"+Chr(10)+Chr(10)
  txt+"Copyright"+Chr(169)+"2003 Reel Media Productions"+Chr(10)
  txt+"written by Paul Leischow"+Chr(10)
  txt+"July 21, 2003"+Chr(10)+Chr(10)
  txt+"Makes use of the Microsoft Cards.DLL"
  SetGadgetText(#Gadget_About_Credits,txt)
EndIf
  
If Window_Main()
  CallFunctionFast(cdtInit,@w,@h)   
  Cash=50
  SetGadgetState(#Gadget_Main_Bet1,1)
  Game_Over("Start Game")
  Draw_Cards(cdtDrawExt,Cash)
  
  quitMain=0
  Repeat
    EventID=WaitWindowEvent()
    Select EventID
      Case #PB_Event_CloseWindow
        If EventWindowID()=#Window_Main
          quitMain=1
        EndIf
      
      Case #PB_Event_Menu
        Select EventMenuID()
          Case #MenuBar_Main_Exit
            quitMain=1
          Case #MenuBar_Main_About
            HideWindow(#Window_About,0)            
            quitAbout=0
            Repeat
              If WaitWindowEvent()=#PB_Event_CloseWindow
                If EventWindowID()=#Window_About
                  quitAbout=1
                EndIf
              EndIf
            Until quitAbout
            HideWindow(#Window_About,1)
        EndSelect
        
        
      Case #PB_Event_Repaint
        Draw_Cards(cdtDrawExt,Cash) 
        
      Case #PB_Event_Gadget
        Select EventGadgetID()
          Case #Gadget_Main_Info
            Gosub Reset_Game
            
          Case #Gadget_Main_Hit
            PlaceBet=1
            playercard+1
            Deal_Card(playercard)
            Draw_Cards(cdtDrawExt,Cash)
            If playercard=6
              Deal_Card(1)
              Draw_Cards(cdtDrawExt,Cash)
              dealer=Dealer_Score()
              player=Player_Score()
              Score=1            
              Else
              player=Player_Score()
              Score=2
            EndIf
         
          Case #Gadget_Main_Stand
            Deal_Card(1)
            Draw_Cards(cdtDrawExt,Cash)
            dealer=Dealer_Score()
            player=Player_Score()
            Score=1                        
        EndSelect
        
        DisableGadget(#Gadget_Main_Bet1,PlaceBet)
        DisableGadget(#Gadget_Main_Bet2,PlaceBet)
        DisableGadget(#Gadget_Main_Bet3,PlaceBet)
        
        If GetGadgetState(#Gadget_Main_Bet1):Bet=1:EndIf
        If GetGadgetState(#Gadget_Main_Bet2):Bet=5:EndIf
        If GetGadgetState(#Gadget_Main_Bet3):Bet=10:EndIf
        Select Score
          Case 1
            If dealer=22:dealer=12:EndIf            
            If player>dealer
              Cash+Bet
              Game_Over("You Win!")
            EndIf
            If player<dealer
              Cash-Bet
              Game_Over("You Lose!")
            EndIf
            If player=dealer
              Cash-Bet
              Game_Over("Tie - You Lose!")
            EndIf
            
          Case 2
            If player>21
              Cash-Bet
              Game_Over("You Lose!")
            EndIf 
        EndSelect
        
    EndSelect
    
    
    If Cash<=0
      If MessageRequester("Game Over","You have lost all your Money!"+Chr(10)+"Would you like to Play Again?",#MB_ICONINFORMATION|#MB_YESNO)=6
        Cash=50
        Gosub Reset_Game
        Else
        quitMain=1
      EndIf
    EndIf
    If Cash>=500
      If MessageRequester("You Win","$$$ You Broke the Bank $$$"+Chr(10)+"Would you like to Play Again?",#MB_ICONINFORMATION|#MB_YESNO)=6
        Cash=50
        Gosub Reset_Game
        Else
        quitMain=1
      EndIf
    EndIf
    
  Until quitMain
  CloseWindow(#Window_Main)
  CallFunctionFast(cdtTerm)
EndIf

CloseLibrary(#DLL)
DeleteFile(tempdir+"Cards32.dll")
End



;--------------------
;-Reset_Game:
Reset_Game:
  Dim card.Deck(6)
  playercard=2
  Deal_Card(0)
  Deal_Card(playercard)
  Draw_Cards(cdtDrawExt,Cash)
  PlaceBet=0
  Score=0 
  HideGadget(#Gadget_Main_Hit,0)
  HideGadget(#Gadget_Main_Stand,0)
  HideGadget(#Gadget_Main_Info,1)   
Return


DataSection
  carddll:IncludeBinary "Cards.dll"
  carddllend:
EndDataSection

















; ExecutableFormat=Windows
; EnableXP
; UseIcon=D:\PB Snippets\Cards\Source\Images\CARDS.ICO
; Executable=D:\PB Snippets\Cards\Source\BlackJack.exe
; DisableDebugger
; EOF